package cn.ibizlab.businesscentral.core.odoo_ir.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.businesscentral.core.odoo_ir.domain.Ir_model_fields;
import cn.ibizlab.businesscentral.core.odoo_ir.filter.Ir_model_fieldsSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface Ir_model_fieldsMapper extends BaseMapper<Ir_model_fields>{

    Page<Ir_model_fields> searchDefault(IPage page, @Param("srf") Ir_model_fieldsSearchContext context, @Param("ew") Wrapper<Ir_model_fields> wrapper) ;
    Page<Ir_model_fields> searchTrackingFields(IPage page, @Param("srf") Ir_model_fieldsSearchContext context, @Param("ew") Wrapper<Ir_model_fields> wrapper) ;
    @Override
    Ir_model_fields selectById(Serializable id);
    @Override
    int insert(Ir_model_fields entity);
    @Override
    int updateById(@Param(Constants.ENTITY) Ir_model_fields entity);
    @Override
    int update(@Param(Constants.ENTITY) Ir_model_fields entity, @Param("ew") Wrapper<Ir_model_fields> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<Ir_model_fields> selectByModelId(@Param("id") Serializable id) ;

}
